<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form
      v-show="showSearch"
      ref="queryForm"
      :model="queryParams"
      size="small"
      label-width="68px"
    >
      <QueryFormWrapper>
        <el-col :span="8">
          <el-form-item label="物料编码" prop="materialNo">
            <el-input
              v-model="queryParams.materialNo"
              placeholder="请输入物料编码"
              clearable
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="物料名称" prop="materialName">
            <el-input
              v-model="queryParams.materialName"
              placeholder="请输入物料名称"
              clearable
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="仓库" prop="wmsStockId">
            <StockSelect
              :ref="`stock1`"
              v-model="queryParams.wmsStockId"
              filterable
              @change="($event) => { stockChange($event) }"
            />
          </el-form-item>
        </el-col>
        <div slot="right">
          <el-form-item label-width="0" class="text-right" style="word">
            <EasyAdvancedQuery class="mr10" label-width="98px" @advQuery="advQuery">
              <template #default="{model}">
                <el-row :gutter="10" type="flex">
                  <el-col :span="12">
                    <el-form-item label="区域" prop="wmsStoreAreaId">
                      <AreaSelect
                        :ref="`area1`"
                        v-model="model.wmsStoreAreaId"
                        filterable
                        @change="($event) => { areaChange($event) }"
                      />
                    </el-form-item>
                  </el-col>
                  <el-col :span="12">
                    <el-form-item label="货位" prop="wmsStockLocationId">
                      <LocationSelect :ref="`location1`" v-model="model.wmsStockLocationId" filterable />
                    </el-form-item>
                  </el-col>
                </el-row>
              </template>
            </EasyAdvancedQuery>
            <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
          </el-form-item>
        </div>
      </QueryFormWrapper>

    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['wms:inventory-general:export']"
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar
        :columns="columnsList"
        :show-search.sync="showSearch"
        @saveSetting="getColumnsList"
        @queryTable="getList"
      />
    </el-row>

    <!-- 列表 -->
    <AutoResizer :given-height="177">
      <template #default="{height}">
        <el-table
          v-if="columnsList.length > 0"
          v-loading="loading"
          :data="list"
          :height="height"
          border
          :summary-method="getSummaries"
          show-summary
        >
          <el-table-column
            v-if="columnsList[0].visible"
            :key="Math.random()"
            label="物料编码"
            align="center"
            prop="materialNo"
            fixed="left"
            show-overflow-tooltip
          />
          <el-table-column
            v-if="columnsList[1].visible"
            :key="Math.random()"
            label="物料名称"
            align="center"
            prop="materialName"
            min-width="130"
            show-overflow-tooltip
          />
          <el-table-column
            v-if="columnsList[2].visible"
            :key="Math.random()"
            label="货存类别"
            align="center"
            prop="categoryName"
            show-overflow-tooltip
          />
          <el-table-column
            v-if="columnsList[3].visible"
            :key="Math.random()"
            label="库存状态"
            align="center"
            prop="stockStatus"
            show-overflow-tooltip
          />
          <el-table-column
            v-if="columnsList[4].visible"
            :key="Math.random()"
            label="规格型号"
            align="center"
            prop="size"
            show-overflow-tooltip
          />
          <el-table-column
            v-if="columnsList[5].visible"
            :key="Math.random()"
            label="存储条件"
            align="center"
            prop="storageEnvironment"
            show-overflow-tooltip
          />
          <el-table-column
            v-if="columnsList[6].visible"
            :key="Math.random()"
            label="库存单位"
            align="center"
            prop="unitCode"
            show-overflow-tooltip
          />
          <el-table-column
            v-if="columnsList[7].visible"
            :key="Math.random()"
            label="库存量"
            align="center"
            prop="periodBalance"
            show-overflow-tooltip
          >
            <template slot-scope="scope">
              <el-button type="text" @click="handleView(scope.row)">
                {{ scope.row.periodBalance }}
              </el-button>
            </template>
          </el-table-column>
          <el-table-column
            label="操作"
            align="center"
            class-name="small-padding fixed-width"
            width="80"
            fixed="right"
          >
            <template slot-scope="scope">
              <el-button
                size="mini"
                type="text"
                icon="el-icon-view"
                @click="handleDetails(scope.row)"
              >查看</el-button>
            </template>
          </el-table-column>
        </el-table>
      </template>
    </AutoResizer>

    <!-- 分页组件 -->
    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNo"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!-- 物料收发明细查看 -->
    <GeneralDetail ref="generalDetail" />

    <!-- 物料明细 -->
    <InventoryDetail ref="inventoryDetail" />

  </div>
</template>

<script>
import { deleteInventoryGeneral, getInventoryGeneralPage, exportInventoryGeneralExcel } from '@/api/wms/inquirePurchase/inventoryGeneral'
import GeneralDetail from './components/GeneralDetail.vue'
import StockSelect from '../../incoming/wareHousing/components/StockSelect.vue'
import AreaSelect from '../../incoming/wareHousing/components/AreaSelect.vue'
import LocationSelect from '../../incoming/wareHousing/components/LocationSelect.vue'

// 物料明细
import InventoryDetail from '../inventoryInquire/components/InventoryDetail.vue'
import { getFormColumnsList } from '@/api/system/saveColumns/index'
import { mapGetters } from 'vuex'
import { isArray } from 'min-dash'

export default {
  name: 'InventoryGeneral',
  components: {
    GeneralDetail,
    StockSelect,
    AreaSelect,
    LocationSelect,
    InventoryDetail
  },
  data() {
    return {

      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 库存总账列表
      list: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 高级查询参数
      advParams: {},
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        materialNo: null,
        materialName: null,
        stockName: null,
        size: null,
        createTime: [],
        width: null,
        length: null,
        thickness: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      // 显示隐藏列参数
      columns: [
        { key: 0, label: '物料编码', visible: true },
        { key: 1, label: '物料名称', visible: true },
        { key: 2, label: '存货类别', visible: true },
        { key: 3, label: '库存状态', visible: true },
        { key: 4, label: '规格型号', visible: true },
        { key: 5, label: '存储条件', visible: true },
        { key: 6, label: '库存单位', visible: true },
        { key: 7, label: '库存量', visible: true }
      ],
      // 显示隐藏持久化参数
      columnsList: []
    }
  },
  // 获取当前登录用户id
  computed: {
    ...mapGetters([
      'userId'
    ])
  },
  created() {
    // 获取显隐列列表
    this.getColumnsList()
    this.getList()
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true
      // 执行查询
      const params = { ...this.queryParams, ...this.advParams }
      getInventoryGeneralPage(params).then(response => {
        this.list = response.data.list
        this.total = response.data.total
      }).finally(() => {
        this.loading = false
      })
    },
    /** 取消按钮 */
    cancel() {
      this.open = false
      this.reset()
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        materialNo: undefined,
        type: undefined,
        period: undefined,
        openingBalance: undefined,
        periodInQty: undefined,
        periodOutQty: undefined,
        periodBalance: undefined,
        canTradeQty: undefined,
        wmsStockId: undefined
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.advParams = {}
      this.handleQuery()
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id
      this.$modal.confirm('是否确认删除库存总账编号为"' + id + '"的数据项?').then(function() {
        return deleteInventoryGeneral(id)
      }).then(() => {
        this.getList()
        this.$modal.msgSuccess('删除成功')
      }).catch(() => {})
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      const params = { ...this.queryParams }
      params.pageNo = undefined
      params.pageSize = undefined
      this.$modal.confirm('是否确认导出所有库存总账数据项?').then(() => {
        this.exportLoading = true
        return exportInventoryGeneralExcel(params)
      }).then(response => {
        this.$download.excel(response, '即时库存.xls')
        this.exportLoading = false
      }).catch(() => {})
    },
    // 物料收发明细
    handleView(row) {
      const { materialNo, materialName, unitCode, wmsStockLogicId } = row
      this.$refs.generalDetail.queryParams.materialNo = materialNo
      this.$refs.generalDetail.queryParams.materialName = materialName
      this.$refs.generalDetail.queryParams.unitCode = unitCode
      this.$refs.generalDetail.queryParams.wmsStockLogicId = wmsStockLogicId
      this.$refs.generalDetail.open = true
    },
    // 小数处理
    getHandleNumber(val) {
      return Math.round((parseFloat(val) * 100000000)) / 100000000
    },
    // 仓库
    stockChange(item) {
      if (item) {
        const { id } = item
        this.$refs[`area1`].options = []
        this.$refs[`area1`].fetchAreaList(id)
      }
    },
    // 区域
    areaChange(item) {
      if (item) {
        const { id } = item
        this.$refs[`location1`].options = []
        this.$refs[`location1`].fetchLocationList(id)
      }
    },
    // 表尾计算
    getSummaries(param) {
      const { columns, data } = param
      const sums = []
      columns.forEach((column, index) => {
        if (index === 0) {
          sums[index] = '总计'
          return
        }
        const values = data.map(item => Number(item[column.property]))
        if (column.property === 'periodBalance') {
          sums[index] = values.reduce((acc, cur) => {
            const value = Number(cur)
            if (!isNaN(value)) {
              return this.getHandleNumber(acc + cur)
            } else {
              return acc
            }
          }, 0)
          sums[index]
        }
      })
      return sums
    },
    // 物料明细
    handleDetails(row) {
      const { materialNo } = row
      this.$refs.inventoryDetail.queryParams.materialNo = materialNo
      this.$refs.inventoryDetail.title = '物料明细'
      this.$refs.inventoryDetail.open = true
    },
    // 高级查询
    advQuery(advQueryParams) {
      this.advParams = advQueryParams
      this.handleQuery()
    },
    // 获取显示隐藏列
    getColumnsList() {
      const { componentName } = this.$route.meta || null
      const params = {
        userId: this.userId,
        vueForm: componentName
      }
      getFormColumnsList(params).then(res => {
        if (isArray(res.data)) {
          this.columnsList = res.data.length === 0 ? this.columns : res.data
          // 对比默认数据和接口数据，将缺失的列添加到接口数据中
          this.columnsList = this.columns.reduce((acc, defaultColumn) => {
            const found = res.data.find(apiColumn => apiColumn.key === defaultColumn.key)
            if (!found) {
              acc.push({ ...defaultColumn, vueForm: componentName, userId: this.userId, id: null })
            }
            return acc
          }, res.data)
        } else {
          this.columnsList = this.columns
        }
      }).catch((err) => {
        if (err) {
          this.columnsList = this.columns
        }
      })
    }
  }
}
</script>
